Subject: Re: bug#54688: 29.0.50; Sliced image in margin looks bad

From: Eli Zaretskii <[email-masked]>
Date: Sun, 03 Apr 2022 13:54:05 +0300

> From: dalanicolai <[email-masked]>
> Date: Sun, 3 Apr 2022 12:33:01 +0200
> Cc: [email-masked]
> 
> Thank you for the quick reply. However, the height of the image,
> (* 2 (line-pixel-height)), is equal to twice the `default-font-height`
> (the 'line-pixel-height' and 'default-font-height' are equal, here both
> 17).
> 
> So before I add the character after the image, (line-pixel-height)
> returns 17. But when I insert a character after it (with
> 'default-font-height' is 17), the `line-pixel-height` increases to
> 22. So I am not sure how to not let the line height increase.
> I will try to play a little with the :ascent value.

Images can also have margins:

  int
  image_ascent (struct image *img, struct face *face, struct glyph_slice *slice)
  {
    int height;
    int ascent;

    if (slice->height == img->height)
      height = img->height + img->vmargin;
    else if (slice->y == 0)
      height = slice->height + img->vmargin;
    else
      height = slice->height;

Maybe those make the difference?

In any case, once I add a character, the line height grows, which
tells us some vertical dimension somewhere is unaccounted for.